unit carta;

interface   

uses
  SysUtils, Classes, QControls, QGraphics, QDialogs;

type
  TCarta = class(TCustomControl)
  private
    intValor, intNaipe, intTipoBaralho : integer;
    boolMostrar : boolean;
    bmpCarta : TBitmap;
    procedure GravaValor(novoValor : integer);
    procedure GravaNaipe(novoNaipe : integer);
    procedure GravaTipoBaralho(novoTipo : integer);
    procedure GravaMostrar(novoMostrar : boolean);
    procedure AtualizaBmpCarta;
  protected
    { Protected declarations }
  public
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
    procedure Paint; override;
  published
    property Valor : integer read intValor write GravaValor;
    property Naipe : integer read intNaipe write GravaNaipe;
    property Mostrar : boolean read boolMostrar write GravaMostrar;
    property TipoBaralho : integer read intTipoBaralho write GravaTipoBaralho;
    property Color;
    property ParentColor;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
  end;

procedure Register;

{$R baralho.res}

implementation

constructor TCarta.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  bmpCarta := TBitmap.Create;
  with bmpCarta do
    begin
      Width := 71;
      Height := 96;
    end;
  Width := 71;
  Height := 96;
  Valor := 1;
  Naipe := 1;
  TipoBaralho := 1;
  Mostrar := true;
  Color := clSilver;
end;

destructor TCarta.Destroy;
begin
  bmpCarta.free;
  inherited Destroy;
end;

procedure TCarta.GravaValor(novoValor : integer);
begin
  if (novoValor >= 1) and (novoValor <= 13) then
    begin
      intValor := novoValor;
      AtualizaBmpCarta;
    end;
end;

procedure TCarta.GravaTipoBaralho(novoTipo : integer);
begin
  if (novoTipo >= 1) and (novoTipo <= 13) then
    begin
      intTipoBaralho := novoTipo;
      AtualizaBmpCarta;
    end;
end;

procedure TCarta.GravaNaipe(novoNaipe : integer);
begin
  if (novoNaipe >= 1) and (novoNaipe <= 4) then
    begin
      intNaipe := novoNaipe;
      AtualizaBmpCarta;
    end;
end;

procedure TCarta.GravaMostrar(novoMostrar : boolean);
begin
  boolMostrar := novoMostrar;
  AtualizaBmpCarta;
end;

procedure TCarta.AtualizaBmpCarta;
var
  bmpBaralho : TBitmap;
  x,y : integer;
  nomeCarta : string;
begin
  bmpBaralho := TBitmap.Create;
  try
    if boolMostrar then
      begin
        x := intValor;
        y := intNaipe;
      end
    else
      begin
        y := 5;
        x := intTipoBaralho;
      end;
    if x=0 then x:=1;
    nomeCarta := 'c'+intToStr(x)+'_'+intToStr(y)+#0;
    bmpBaralho.LoadFromResourceName(HInstance, nomeCarta);
    bmpCarta.Canvas.Draw(0,0,bmpBaralho);
  finally
    bmpBaralho.Free;
  end;
  Invalidate;
end;

procedure TCarta.Paint;
begin
  inherited Paint;
  with Canvas do
    begin
      Draw(0,0,bmpCarta);
      Pen.Color := Color;
      DrawPoint( 0 ,0);
      DrawPoint( 1, 0);
      DrawPoint( 0, 1);
      DrawPoint(69, 0);
      DrawPoint(70, 0);
      DrawPoint(70, 1);
      DrawPoint( 0,95);
      DrawPoint( 1,95);
      DrawPoint( 0,94);
      DrawPoint(69,95);
      DrawPoint(70,95);
      DrawPoint(70,94);
    end;

end;

procedure Register;
begin
  RegisterComponents('Truco', [TCarta]);
end;

end.

